<template>
  <div v-if="!item.hidden && item.children" class="menu-wrapper">
    <template
      v-if="hasOneShowingChild(item.children, item) && (!onlyOneChild.children || onlyOneChild.noShowingChildren) && !item.alwaysShow">
      <a :href="onlyOneChild.path" target="_blank" @click="clickLink(onlyOneChild.path, $event)">
        <el-menu-item :index="resolvePath(onlyOneChild.path)" :class="{ 'submenu-title-noDropdown': !isNest }">
          <item v-if="onlyOneChild.meta" :icon="onlyOneChild.meta.icon || item.meta.icon"
            :title="onlyOneChild.meta.title" />
        </el-menu-item>
      </a>
    </template>

    <el-submenu v-else :index="item.name || item.path">
      <template slot="title">
        <item v-if="item.meta" :icon="item.meta.icon" :title="item.meta.title" />
      </template>

      <template v-for="child in item.children" v-if="!child.hidden">
        <sidebar-item v-if="child.children && child.children.length > 0" :is-nest="true" :item="child" :key="child.path"
          :base-path="resolvePath(child.path)" class="nest-menu" />
        <a v-else :href="child.path" :key="child.name" target="_blank" @click="clickLink(child.path, $event)">
          <el-menu-item :index="resolvePath(child.path)">
            <item v-if="child.meta" :icon="child.meta.icon" :title="child.meta.title" />
          </el-menu-item>
        </a>
      </template>
    </el-submenu>

  </div>
</template>

<script>
import path from 'path'
import { validateURL } from '@/utils/validate'
import Item from './Item'
import { mapGetters } from 'vuex'


export default {
  name: 'SidebarItem',
  components: { Item },
  props: {
    // route object
    item: {
      type: Object,
      required: true
    },
    isNest: {
      type: Boolean,
      default: false
    },
    basePath: {
      type: String,
      default: ''
    }
  },
  data() {
    return {
      onlyOneChild: null
    }
  },
  computed: {
    ...mapGetters([
      'name',
      'token',
      'id'
    ])
  },
  methods: {
    hasOneShowingChild(children, parent) {
      const showingChildren = children.filter(item => {
        if (item.hidden) {
          return false
        } else {
          // Temp set(will be used if only has one showing child)
          this.onlyOneChild = item
          return true
        }
      })

      // When there is only one child router, the child router is displayed by default
      if (showingChildren.length === 1) {
        return true
      }

      // Show parent if there are no child router to display
      if (showingChildren.length === 0) {
        this.onlyOneChild = { ...parent, path: '', noShowingChildren: true }
        return true
      }

      return false
    },
    resolvePath(routePath) {
      return path.resolve(this.basePath, routePath)
    },
    isExternalLink(routePath) {
      return validateURL(routePath)
    },
    clickLink(routePath, e) {
      // console.log('触发跳转方法!!',routePath,e.srcElement.innerText)

      if (routePath, e.srcElement.innerText == '远程监控系统') {
        //定制秘钥，长度必须为：8/16/32位 一般是通过发起新的请求获取
        var aseKey = "meswork."
        var data = String(this.id)
        console.log('data', data)
        //加密 DES/AES切换只需要修改 CryptoJS.AES <=> CryptoJS.DES
        var encrypt = this.$CryptoJS.AES.encrypt(data, this.$CryptoJS.enc.Utf8.parse(aseKey), {
          mode: this.$CryptoJS.mode.ECB,
          padding: this.$CryptoJS.pad.Pkcs7
        }).toString();
        console.log('这是加密的文本', encrypt)
        // var decrypt = CryptoJS.AES.decrypt(encrypt, CryptoJS.enc.Utf8.parse(aseKey), {
        //   mode: CryptoJS.mode.ECB,
        //   padding: CryptoJS.pad.Pkcs7
        // }).toString(CryptoJS.enc.Utf8)
        var encodedEncrypt = encodeURIComponent(encrypt);
        // console.log('这是解密后的文本', decrypt)
        console.log('这是加密的文本22', encodedEncrypt)
        window.location.href = routePath+ '?Uid='+ encodedEncrypt
        return;
      }
      if (!this.isExternalLink(routePath)) {
        e.preventDefault()
        const path = this.resolvePath(routePath)
        this.$router.push(path)
      }
    }
  }
}
</script>
